package com.its.op.service.its.scrs;

import com.its.op.dao.repository.its.scrs.TbScSgnlIxrSttsRepository;
import com.its.op.dto.its.scrs.TbScSgnlIxrSttsDto;
import com.its.op.entity.its.scrs.TbScSgnlIxrStts;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbScSgnlIxrSttsService {

    private final TbScSgnlIxrSttsRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbScSgnlIxrStts requireOne(Integer sgnlIxrNmbr) throws NoSuchElementException {
        Optional<TbScSgnlIxrStts> info = this.repo.findById(sgnlIxrNmbr);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + sgnlIxrNmbr);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScSgnlIxrSttsDto> findAll() {
        List<TbScSgnlIxrSttsDto> result = new ArrayList<>();
        List<TbScSgnlIxrStts> data = this.repo.findAll();
        for (TbScSgnlIxrStts entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbScSgnlIxrSttsDto> findAllList() {
        List<TbScSgnlIxrSttsDto> result = new ArrayList<>();
        List<TbScSgnlIxrStts> data = this.repo.findAllList();
        for (TbScSgnlIxrStts entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbScSgnlIxrSttsDto findById(Integer sgnlIxrNmbr) {
        TbScSgnlIxrStts entity = requireOne(sgnlIxrNmbr);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbScSgnlIxrSttsDto updateById(Integer sgnlIxrNmbr, TbScSgnlIxrSttsDto.TbScSgnlIxrSttsUpdReq req) {
        TbScSgnlIxrStts entity = requireOne(sgnlIxrNmbr);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbScSgnlIxrSttsDto> mergeInfoList(List<TbScSgnlIxrSttsDto.TbScSgnlIxrSttsUpdReq> reqList) {
        List<TbScSgnlIxrSttsDto> result = new ArrayList<>();
        for (TbScSgnlIxrSttsDto.TbScSgnlIxrSttsUpdReq req : reqList) {
            TbScSgnlIxrStts obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbScSgnlIxrSttsDto mergeInfo(TbScSgnlIxrSttsDto.TbScSgnlIxrSttsUpdReq req) {
        TbScSgnlIxrStts obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbScSgnlIxrSttsDto deleteById(Integer sgnlIxrNmbr) {
        TbScSgnlIxrStts entity = requireOne(sgnlIxrNmbr);
        this.repo.deleteById(sgnlIxrNmbr);
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbScSgnlIxrSttsDto> deleteByIds(List<Integer> ids) {
        List<TbScSgnlIxrSttsDto> result = new ArrayList<>();
        for (Integer id : ids) {
            Optional<TbScSgnlIxrStts> obj = this.repo.findById(id);
            if (obj.isPresent()) {
                this.repo.deleteById(id);
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
